# Workaround for "ERROR: Cannot copy 'SemaphoreSet.pm' to '../blib/lib/Coro/SemaphoreSet.pm': Permission denied":
%global _smp_ncpus_max 4

%define upstream_name    Coro
%define upstream_version 6.57

#define _without_check 1

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %upstream_version
Release:    %mkrel 5
Epoch:      3

Summary:    Coroutine process abstraction
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        https://metacpan.org/release/%{upstream_name}
Source0:    https://cpan.metacpan.org/authors/id/M/ML/MLEHMANN/%{upstream_name}-%{upstream_version}.tar.gz
Patch0:     %{name}-5.25-ucontext-default.patch

BuildRequires: perl(AnyEvent) >= 5.0.0
BuildRequires: perl(Canary::Stability)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(Guard) >= 0.500.0
BuildRequires: perl(Scalar::Util)
BuildRequires: perl(Storable) >= 2.150.0
BuildRequires: perl(common::sense)
BuildRequires: perl-devel
Obsoletes:  perl-Coro-EV       <= 2:6.330.0
Obsoletes:  perl-Coro-AnyEvent <= 2:6.330.0
Obsoletes:  perl-Coro-BDB      <= 2:6.330.0
# Export correct required versions
Requires:   perl(AnyEvent) >= 7
Requires:   perl(AnyEvent::AIO) >= 1
Requires:   perl(AnyEvent::BDB) >= 1
Requires:   perl(EV) >= 4
Requires:   perl(Event) >= 1.08
Requires:   perl(Guard) >= 0.5
Requires:   perl(Storable) >= 2.15

%{?perl_default_filter}

%global __requires_exclude perl\\(Exporter::\\)|perl\\(Coro::Socket::\\)
# Filter underspecified dependencies
%global __requires_exclude %{?__requires_exclude:__requires_exclude|}^perl\\(AnyEvent\\)$
%global __requires_exclude %__requires_exclude|^perl\\(AnyEvent\\) >= 4.800001$
%global __requires_exclude %__requires_exclude|^perl\\(Guard\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Storable\\)$
%global __provides_exclude %{?__provides_exclude:__provides_exclude|}^perl\\(Coro\\)$

%description
This module collection manages continuations in general, most often in the
form of cooperative threads (also called coros, or simply "coro" in the
documentation). They are similar to kernel threads but don't (in general) run
in parallel at the same time even on SMP machines. The specific flavor of
thread offered by this module also guarantees you that it will not switch
between threads unless necessary, at easily-identified points in your
program, so locking and parallel access are rarely an issue, making thread
programming much safer and easier than using other thread models.

%prep
%setup -q -n %{upstream_name}-%{upstream_version} 
%ifnarch %{ix86} x86_64 %{arm}
# use ucontext backend on non-x86 (setjmp didn't work on s390(x))
%patch0 -p1 -b .ucontext-default
%endif
# Correct shebangs
for F in Coro/jit-*.pl; do
    perl -i -ne 'print $_ unless m{\A#!}' "$F"
    chmod -x "$F"
done
# remove failing test - http://rt.cpan.org/Ticket/Display.html?id=32475
rm EV/t/01_unblock.t

%build
# Disable FORTIFY_SOURCE on ARM as it breaks setjmp - RHBZ 750805
%ifarch %{arm}
RPM_OPT_FLAGS="${RPM_OPT_FLAGS} -Wp,-U_FORTIFY_SOURCE -Wp,-D_FORTIFY_SOURCE=0"
%endif

# Interactive configuration. Use default values.
perl Makefile.PL INSTALLDIRS=vendor </dev/null
%make_build CFLAGS="%{optflags}"

%install
%make_install

%check
%{!?_without_check:make test}

%files
%license COPYING
%doc COPYING Changes EV INSTALL META.json META.yml MYMETA.yml README eg
%{perl_vendorarch}/*
%_mandir/man3/*


%changelog
* Tue Jun 07 2022 umeabot <umeabot> 3:6.570.0-5.mga9
+ Revision: 1862852
- Rebuild for Perl 5.36

* Thu Mar 17 2022 umeabot <umeabot> 3:6.570.0-4.mga9
+ Revision: 1796781
- Mageia 9 Mass Rebuild

* Mon Jul 19 2021 tv <tv> 3:6.570.0-3.mga9
+ Revision: 1736921
- Modernize fixing shebangs
+ tmb <tmb>
- rebuild for perl 5.34
+ umeabot <umeabot>
- Rebuild for perl 5.34

* Sat Aug 01 2020 tv <tv> 3:6.570.0-1.mga8
+ Revision: 1610197
- update to 6.57

* Thu Jun 18 2020 umeabot <umeabot> 3:6.550.0-6.mga8
+ Revision: 1596053
- Rebuild for perl 5.32
- Rebuild for perl 5.32

* Sun Feb 16 2020 umeabot <umeabot> 3:6.550.0-4.mga8
+ Revision: 1529425
- Mageia 8 Mass Rebuild

* Tue Aug 27 2019 tmb <tmb> 3:6.550.0-3.mga8
+ Revision: 1433426
- rebuild for perl 5.30

* Mon Jul 22 2019 tv <tv> 3:6.550.0-2.mga8
+ Revision: 1423437
- limit max CPU in order to workarounding "ERROR: Cannot copy 'SemaphoreSet.pm'
  to '../blib/lib/Coro/SemaphoreSet.pm': Permission denied" on BS
- update to 6.55

* Thu Dec 20 2018 tv <tv> 3:6.540.0-1.mga7
+ Revision: 1343423
- update to 6.54

* Fri Sep 21 2018 umeabot <umeabot> 3:6.520.0-2.mga7
+ Revision: 1292540
- Mageia 7 Mass Rebuild
+ shlomif <shlomif>
- update to 6.52

* Thu Aug 09 2018 pterjan <pterjan> 3:6.514.0-6.mga7
+ Revision: 1250709
- Rebuild for perl 5.28
- Rebuild for perl 5.28

* Mon Oct 02 2017 tv <tv> 3:6.514.0-3.mga7
+ Revision: 1163579
- rebuild with fixed rpm for missing autodeps

* Thu Sep 28 2017 tv <tv> 3:6.514.0-2.mga7
+ Revision: 1161047
- add missing requires, thus other pkg builds

* Mon Sep 25 2017 guillomovitch <guillomovitch> 3:6.514.0-1.mga7
+ Revision: 1158918
- new version 6.514

* Mon Jul 24 2017 sander85 <sander85> 3:6.513.0-1.mga7
+ Revision: 1129898
- update to 6.513
+ neoclust <neoclust>
- Rebuild against new Perl 5.26

* Thu Jun 16 2016 tv <tv> 3:6.490.0-3.mga6
+ Revision: 1021646
- better description
- use %%license
- do use our flags (fixing arm build)

* Wed Jun 15 2016 tv <tv> 3:6.490.0-2.mga6
+ Revision: 1021549
- add arm fixes from FC

* Sun May 08 2016 shlomif <shlomif> 3:6.490.0-1.mga6
+ Revision: 1010575
- update to 6.49
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Thu Nov 19 2015 neoclust <neoclust> 3:6.480.0-3.mga6
+ Revision: 904257
- Rebuild on arm

* Sun Nov 15 2015 tv <tv> 3:6.480.0-2.mga6
+ Revision: 903340
- new release

* Wed Oct 21 2015 tv <tv> 3:6.470.0-2.mga6
+ Revision: 893415
- rebuild with fixed deps

* Mon Jul 13 2015 sander85 <sander85> 3:6.470.0-1.mga6
+ Revision: 853589
- update to 6.47

* Thu Jul 02 2015 tv <tv> 3:6.460.0-1.mga6
+ Revision: 849561
- new release
- new release
- rebuild for soname-ifed perl
- just accept defaults
- BR perl(Canary::Stability)
- new release
- rebuild for perl-5.22

* Wed Oct 15 2014 umeabot <umeabot> 2:6.410.0-5.mga5
+ Revision: 749970
- Second Mageia 5 Mass Rebuild

* Tue Sep 30 2014 tv <tv> 2:6.410.0-4.mga5
+ Revision: 732962
- add exclude

* Tue Sep 16 2014 umeabot <umeabot> 2:6.410.0-3.mga5
+ Revision: 684025
- Mageia 5 Mass Rebuild
+ tv <tv>
- use %%global for req/prov exclude
- autoconvert to new prov/req excludes

* Sun Sep 07 2014 sander85 <sander85> 2:6.410.0-2.mga5
+ Revision: 673118
- update to 6.41

* Wed Jun 04 2014 sander85 <sander85> 2:6.390.0-2.mga5
+ Revision: 632975
- bump rel
- update to 6.39
+ jquelin <jquelin>
- perl 5.20.0 rebuild

* Fri Mar 14 2014 jquelin <jquelin> 2:6.370.0-2.mga5
+ Revision: 603826
- update list of obsoletes
- update obsoletes

* Thu Mar 13 2014 jquelin <jquelin> 2:6.370.0-1.mga5
+ Revision: 602862
- update to 6.37

* Thu Mar 13 2014 jquelin <jquelin> 2:6.330.0-2.mga5
+ Revision: 602831
- get rid of subpackages

* Mon Feb 10 2014 jquelin <jquelin> 2:6.330.0-1.mga5
+ Revision: 588116
- update to 6.33

* Sat Oct 19 2013 umeabot <umeabot> 2:6.310.0-2.mga4
+ Revision: 526302
- Mageia 4 Mass Rebuild

* Mon Jun 03 2013 jquelin <jquelin> 2:6.310.0-1.mga4
+ Revision: 436485
- update to 6.31

* Wed May 29 2013 jquelin <jquelin> 2:6.230.0-3.mga4
+ Revision: 432090
- perl 5.18.0 rebuild

* Sun Jan 13 2013 umeabot <umeabot> 2:6.230.0-2.mga3
+ Revision: 364825
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 jquelin <jquelin> 2:6.230.0-1.mga3
+ Revision: 341970
- update to 6.23

* Mon Oct 15 2012 jquelin <jquelin> 2:6.100.0-1.mga3
+ Revision: 306069
- update to 6.10

* Fri Aug 24 2012 pterjan <pterjan> 2:6.80.0-2.mga3
+ Revision: 283466
- Rebuild for new perl

* Tue Jun 05 2012 jquelin <jquelin> 2:6.80.0-1.mga3
+ Revision: 254725
- update to 6.08

* Wed May 30 2012 jquelin <jquelin> 2:6.70.0-2.mga3
+ Revision: 250386
- rebuild for perl 5.16

* Fri Nov 11 2011 kharec <kharec> 2:6.70.0-1.mga2
+ Revision: 166824
- update to 6.07
+ jquelin <jquelin>
- update to 6.06
- update to 6.02

* Fri Jul 08 2011 jquelin <jquelin> 2:6.10.0-1.mga2
+ Revision: 120366
- update to 6.01

* Thu Jun 30 2011 jquelin <jquelin> 2:6.0.0-2.mga2
+ Revision: 116723
- rebuild
- remove erroneous shebangs

* Thu Jun 30 2011 jquelin <jquelin> 2:6.0.0-1.mga2
+ Revision: 116473
- update to 6.0

* Fri Feb 25 2011 jquelin <jquelin> 2:5.372.0-1.mga2
+ Revision: 59636
- update to 5.372

* Tue Feb 22 2011 jquelin <jquelin> 2:5.371.0-1.mga1
+ Revision: 56509
- update to 5.371

* Mon Jan 24 2011 jquelin <jquelin> 2:5.250.0-1.mga1
+ Revision: 37015
- adding missing buildrequires:
- remove blocking EV test
- shipping perl-Coro-EV
- mageia rebuild
- remove files not found
- mageia rebuild
- imported package perl-Coro


* Thu Nov 11 2010 Götz Waschk <waschk@mandriva.org> 2:5.250.0-1mdv2011.0
+ Revision: 595977
- update to new version 5.25

* Sun Oct 24 2010 Götz Waschk <waschk@mandriva.org> 2:5.240.0-1mdv2011.0
+ Revision: 588036
- update to new version 5.24

* Tue Jul 20 2010 Jérôme Quelin <jquelin@mandriva.org> 2:5.230.0-2mdv2011.0
+ Revision: 555716
- rebuild

* Sat Jul 10 2010 Götz Waschk <waschk@mandriva.org> 2:5.230.0-1mdv2011.0
+ Revision: 550299
- update to new version 5.23

* Wed Apr 14 2010 Götz Waschk <waschk@mandriva.org> 2:5.220.0-1mdv2010.1
+ Revision: 534703
- update to new version 5.22

* Thu Dec 17 2009 Götz Waschk <waschk@mandriva.org> 2:5.210.0-1mdv2010.1
+ Revision: 479696
- new version
- fix source URL

* Fri Nov 06 2009 Götz Waschk <waschk@mandriva.org> 2:5.200.0-1mdv2010.1
+ Revision: 460738
- new version
- update build deps

* Mon Aug 24 2009 Götz Waschk <waschk@mandriva.org> 2:5.170.0-1mdv2010.0
+ Revision: 420258
- new version

* Mon Aug 03 2009 Götz Waschk <waschk@mandriva.org> 2:5.162.0-1mdv2010.0
+ Revision: 407699
- update to new version 5.162

* Thu Jul 23 2009 Jérôme Quelin <jquelin@mandriva.org> 2:5.161.0-1mdv2010.0
+ Revision: 398854
- update to 5.161

* Mon Jul 06 2009 Jérôme Quelin <jquelin@mandriva.org> 2:5.151.0-1mdv2010.0
+ Revision: 392768
- removing EV files
- update to 5.151
- fixed license field

  + Götz Waschk <waschk@mandriva.org>
    - use right version macro

* Sat May 30 2009 Götz Waschk <waschk@mandriva.org> 2:5.132.0-1mdv2010.0
+ Revision: 381508
- new version
- remove the macro definition again

* Fri May 08 2009 Götz Waschk <waschk@mandriva.org> 2:5.131.0-2mdv2010.0
+ Revision: 373415
- resubmit
- add perl_convert_version macro
- use perl version macro

* Tue Mar 17 2009 Götz Waschk <waschk@mandriva.org> 2:5.131-1mdv2009.1
+ Revision: 356529
- update to new version 5.131

* Sun Dec 28 2008 Götz Waschk <waschk@mandriva.org> 2:5.13-1mdv2009.1
+ Revision: 320317
- new version
- depend on perl-Guard

* Mon Dec 08 2008 Götz Waschk <waschk@mandriva.org> 2:5.12-1mdv2009.1
+ Revision: 311732
- update to new version 5.12

* Wed Nov 26 2008 Götz Waschk <waschk@mandriva.org> 2:5.11-1mdv2009.1
+ Revision: 306932
- update to new version 5.11

* Tue Nov 25 2008 Götz Waschk <waschk@mandriva.org> 2:5.1-1mdv2009.1
+ Revision: 306561
- new version
- update file list

* Sun Nov 23 2008 Götz Waschk <waschk@mandriva.org> 2:5.0-1mdv2009.1
+ Revision: 305959
- update to new version 5.0

* Sun Nov 16 2008 Götz Waschk <waschk@mandriva.org> 2:4.913-1mdv2009.1
+ Revision: 303683
- update to new version 4.913

* Fri Nov 14 2008 Götz Waschk <waschk@mandriva.org> 2:4.912-1mdv2009.1
+ Revision: 303106
- update to new version 4.912

* Thu Nov 13 2008 Götz Waschk <waschk@mandriva.org> 2:4.911-1mdv2009.1
+ Revision: 302631
- update to new version 4.911

* Fri Nov 07 2008 Götz Waschk <waschk@mandriva.org> 2:4.804-1mdv2009.1
+ Revision: 300473
- update to new version 4.804

* Tue Nov 04 2008 Götz Waschk <waschk@mandriva.org> 2:4.803-1mdv2009.1
+ Revision: 299817
- update to new version 4.803

* Fri Oct 31 2008 Götz Waschk <waschk@mandriva.org> 2:4.802-1mdv2009.1
+ Revision: 298846
- update to new version 4.802

* Thu Oct 23 2008 Götz Waschk <waschk@mandriva.org> 2:4.801-1mdv2009.1
+ Revision: 296655
- update to new version 4.801

* Sat Oct 11 2008 Götz Waschk <waschk@mandriva.org> 2:4.749-1mdv2009.1
+ Revision: 291907
- new version

* Wed Sep 24 2008 Götz Waschk <waschk@mandriva.org> 2:4.747-1mdv2009.0
+ Revision: 287714
- update to new version 4.747

* Mon Sep 22 2008 Götz Waschk <waschk@mandriva.org> 2:4.746-1mdv2009.0
+ Revision: 286467
- update to new version 4.746

* Thu Jul 24 2008 Götz Waschk <waschk@mandriva.org> 2:4.745-1mdv2009.0
+ Revision: 244979
- new version

* Wed Jul 09 2008 Götz Waschk <waschk@mandriva.org> 2:4.744-1mdv2009.0
+ Revision: 232902
- new version

* Mon Jun 16 2008 Götz Waschk <waschk@mandriva.org> 2:4.743-1mdv2009.0
+ Revision: 219389
- new version

* Wed May 28 2008 Götz Waschk <waschk@mandriva.org> 2:4.72-1mdv2009.0
+ Revision: 212581
- new version
- bump AnyEvent dep
- add AnyEvent subpackage

* Tue Apr 15 2008 Götz Waschk <waschk@mandriva.org> 2:4.51-1mdv2009.0
+ Revision: 193700
- new version

* Tue Apr 08 2008 Götz Waschk <waschk@mandriva.org> 2:4.49-1mdv2009.0
+ Revision: 192408
- new version

* Mon Jan 21 2008 Götz Waschk <waschk@mandriva.org> 2:4.37-1mdv2008.1
+ Revision: 155570
- new version
- reenable checks

* Thu Jan 17 2008 Götz Waschk <waschk@mandriva.org> 2:4.36-2mdv2008.1
+ Revision: 153984
- disable check for bootstrapping

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

  + Pixel <pixel@mandriva.com>
    - rebuild for perl-5.10.0

* Mon Jan 14 2008 Götz Waschk <waschk@mandriva.org> 2:4.36-1mdv2008.1
+ Revision: 151119
- new version

* Wed Dec 26 2007 Guillaume Rousse <guillomovitch@mandriva.org> 2:4.34-1mdv2008.1
+ Revision: 137993
- update to new version 4.34

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Wed Dec 19 2007 Götz Waschk <waschk@mandriva.org> 2:4.33-2mdv2008.1
+ Revision: 133738
- split out Coro::BDB module

* Tue Dec 18 2007 Götz Waschk <waschk@mandriva.org> 2:4.33-1mdv2008.1
+ Revision: 132036
- new version

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Thu Dec 06 2007 Götz Waschk <waschk@mandriva.org> 2:4.31-1mdv2008.1
+ Revision: 115832
- new version

* Mon Dec 03 2007 Guillaume Rousse <guillomovitch@mandriva.org> 2:4.22-1mdv2008.1
+ Revision: 114489
- update to new version 4.22
- update to new version 4.22

* Mon Nov 26 2007 Götz Waschk <waschk@mandriva.org> 2:4.21-1mdv2008.1
+ Revision: 112121
- new version
- bump dep

* Tue Oct 30 2007 Götz Waschk <waschk@mandriva.org> 2:4.13-1mdv2008.1
+ Revision: 103743
- new version

* Fri Oct 12 2007 Götz Waschk <waschk@mandriva.org> 2:4.11-1mdv2008.1
+ Revision: 97274
- new version

* Sun Oct 07 2007 Götz Waschk <waschk@mandriva.org> 2:4.03-1mdv2008.1
+ Revision: 95677
- new version

* Fri May 18 2007 Götz Waschk <waschk@mandriva.org> 2:3.63-1mdv2008.0
+ Revision: 28296
- new version

* Sat Apr 28 2007 Götz Waschk <waschk@mandriva.org> 2:3.62-1mdv2008.0
+ Revision: 18927
- new version

* Fri Apr 20 2007 Götz Waschk <waschk@mandriva.org> 2:3.61-1mdv2008.0
+ Revision: 16010
- new version


* Wed Mar 28 2007 Götz Waschk <waschk@mandriva.org> 3.55-1mdv2007.1
+ Revision: 149088
- new version

* Tue Mar 06 2007 Götz Waschk <waschk@mandriva.org> 2:3.51-1mdv2007.1
+ Revision: 133462
- new version

* Wed Feb 28 2007 Götz Waschk <waschk@mandriva.org> 2:3.5-1mdv2007.1
+ Revision: 127050
- new version

* Tue Jan 23 2007 Götz Waschk <waschk@mandriva.org> 1:3.41-1mdv2007.1
+ Revision: 112296
- new version

* Sun Jan 21 2007 Götz Waschk <waschk@mandriva.org> 1:3.4-1mdv2007.1
+ Revision: 111288
- new version

* Sun Jan 07 2007 Götz Waschk <waschk@mandriva.org> 1:3.3-1mdv2007.1
+ Revision: 105201
- new version

* Thu Jan 04 2007 Götz Waschk <waschk@mandriva.org> 1:3.2-1mdv2007.1
+ Revision: 104044
- new version
- fix configuration
- reenable checks

* Wed Dec 06 2006 Götz Waschk <waschk@mandriva.org> 3.11-1mdv2007.1
+ Revision: 91719
- Import perl-Coro

* Wed Dec 06 2006 Götz Waschk <waschk@mandriva.org> 3.11-1mdv2007.1
- disable check for bootstrapping
- fix build
- New version 3.11

* Tue May 16 2006 Götz Waschk <waschk@mandriva.org> 1.9-2mdk
- fix deps

* Wed May 10 2006 Götz Waschk <waschk@mandriva.org> 1.9-1mdk
- First Mandriva package

